// dynload.h*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#ifndef DYNLOAD_H
#define DYNLOAD_H
#include "lrt.h"
// Runtime Loading Declarations
Reference<Shape> CreateShape(const string &name, const string &searchPath,
	const Transform &object2world,
	const ParamSet &paramSet);
Reference<Material> CreateMaterial(const string &name, const string &searchPath,
	const Transform &mtl2world,
	const ParamSet &pgeom, const ParamSet &pshader, const Spectrum &Cs,
	Texture<Float> *disp);
Texture<Float> *CreateBump(const string &name, const string &searchPath,
	const Transform &xform, const ParamSet &pgeom, const ParamSet &pdisp);
Light *CreateLight(const string &name, const string &searchPath,
	bool castsShadows, const Transform &light2world,
	const ParamSet &paramSet);
AreaLight *CreateAreaLight(const string &name, const string &searchPath,
	bool castsShadows, const Transform &light2world,
	const ParamSet &paramSet, const Reference<Shape> &shape);
VolumeRegion *CreateVolumeRegion(const string &name, const string &searchPath,
	const Transform &light2world, const ParamSet &paramSet);
SurfaceIntegrator *CreateSurfaceIntegrator(const string &name, const string &searchPath,
		const ParamSet &paramSet);
VolumeIntegrator *CreateVolumeIntegrator(const string &name, const string &searchPath,
		const ParamSet &paramSet);
Primitive *CreateAccelerator(const string &name, const string &searchPath,
		const vector<Reference<Primitive> > &prims,
		const ParamSet &paramSet);
Camera *CreateCamera(const string &name, const string &searchPath,
	const ParamSet &paramSet, const Transform &world2cam, Film *film);
Sampler *CreateSampler(const string &name, const string &searchPath,
	const ParamSet &paramSet, int xres, int yres, int xsamp, int ysamp,
	const Extent2D &crop, Filter *filter);
Filter *CreateFilter(const string &name, const string &searchPath,
	const ParamSet &paramSet, Float xWidth, Float yWidth);
ToneMap *CreateToneMap(const string &name, const string &searchPath,
	const ParamSet &paramSet);
#endif // DYNLOAD_H
