// lrt.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "lrt.h"
#include "ri.h"
// main program
int main(int argc, char *argv[]) {
	fprintf(stderr, "lrt (sucks) version %1.3f of %s at %s\n",
		LRT_VERSION, __DATE__, __TIME__);
	// System-wide Initialization
	// Make sure floating point unit's rounding stuff is set
	// as is expected by the fast FP-conversion routines.  In particular,
	// we want double precision on Linux, not extended precision!
	#ifdef FAST_INT
	#if defined(__linux__) && defined(__i386__)
	int cword = _FPU_MASK_DM | _FPU_MASK_ZM | _FPU_MASK_OM | _FPU_MASK_PM |
		_FPU_MASK_UM | _FPU_MASK_IM | _FPU_DOUBLE | _FPU_RC_NEAREST;
	_FPU_SETCW(cword);
	#endif
	#if defined(WIN32)
	_control87(_PC_53, MCW_PC);
	#endif
	#endif // FAST_INT
	InitAPI();
	// Process scene description
	if (argc == 1) {
		// Parse scene from standard input
		ParseFile("-");
	} else {
		int a=1;
		if(strcmp(argv[1],"snow")==0) {
			isCreateBlob=true;
			a=2;
		}
		else
			isCreateBlob=false;
		// Parse scene from input files
		for (int i = a; i < argc; i++)
			if (!ParseFile(argv[i]))
				Error("Couldn't open input file \"%s\"\n", argv[i]);
	}
	// System-wide cleanup
	StatsCleanup();
	//currentApiState = STATE_UNINITIALIZED;
	return 0;
}
