// transport.h*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#ifndef TRANSPORT_H
#define TRANSPORT_H
#include "lrt.h"
#include "primitives.h"
#include "color.h"
#include "light.h"
#include "reflection.h"
#include "sampling.h"
#include "materials.h"
// Integrator Declarations
class Integrator {
public:
	// Integrator Method Declarations
	virtual ~Integrator();
	virtual Spectrum L(const Scene *, const RayDifferential &ray,
		const Sample *sample, Float *alpha) const = 0;
	virtual void Preprocess(const Scene *scene) {
	}
	virtual void RequestSamples(Sample *sample, const Scene *scene) {
	}
};
class SurfaceIntegrator : public Integrator {
};
#endif // TRANSPORT_H
