// triangle.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "sampling.h"
#include "paramset.h"
// Triangle Filter Declarations
class TriangleFilter : public Filter {
public:
	TriangleFilter(Float xw, Float yw) : Filter(xw, yw) { }
	Float Evaluate(Float x, Float y) const;
};
// Triangle Filter Definitions
Float TriangleFilter::Evaluate(Float x, Float y) const {
	return max(0.f, halfXWidth - fabsf(x)) *
		max(0.f, halfYWidth - fabsf(y));
}
extern "C" Filter *CreateFilter(const ParamSet &ps, Float xw, Float yw) {
	return new TriangleFilter(xw, yw);
}
