// null.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "volume.h"
#include "transport.h"
// NullVolumeIntegrator Declarations
class NullVolumeIntegrator : public VolumeIntegrator {
public:
	Spectrum Transmittance(const Scene *, const Ray &ray,
		const Sample *sample, Float *alpha) const {
		return Spectrum(1.);
	}
	Spectrum L(const Scene *, const RayDifferential &ray,
		const Sample *sample, Float *alpha) const {
		return Spectrum(0.);
	}
};
// NullVolumeIntegrator Function Definitions
extern "C" VolumeIntegrator *CreateVolumeIntegrator(const ParamSet &params) {
	return new NullVolumeIntegrator;
}
