// bumpy.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "lrt.h"
#include "materials.h"
// Bumpy Creation Function
extern "C" Texture<Float> *CreateBump(const Transform &shader2world,
		const ParamSet &geomParams,
		const ParamSet &displaceParams) {
	// 6., .5, 1.
	Float octaves = DISP_FLOAT_PARAM("octaves", 6.);
	Float omega = DISP_FLOAT_PARAM("omega", .5);
	Texture<Float> *d = new BumpyTexture((int)octaves, omega,
			new IdentityMapping3D(Transform()));
	DISP_TEX_F(scale, 1.);
	return new ScaleTexture<Float, Float>(scale, d);
}
