// imagemap.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "lrt.h"
#include "materials.h"
// ImageMap Creation Function
extern "C" Texture<Float> *CreateBump(const Transform &shader2world,
		const ParamSet &geomParams,
		const ParamSet &displaceParams) {
	string filename = geomParams.FindOneString("texturename",
		displaceParams.FindOneString("texturename", ""));
	DISP_TEX_F(scale, 1.);
	if (filename != "") {
		Texture<Float> *d = new ImageTexture<Float>(
			new IdentityMapping2D, filename);
		return new ScaleTexture<Float, Float>(scale, d);
	}
	return NULL;
}
