#ifndef POOL_H
#define POOL_H

#include "Object3d.h"
#include "Block.h"
#include "Vectors.h"

typedef struct {
	wldQuad faces[5];				// a hole in the floor...
} wldPool;


#include "Player.h"

# define CUBE_MAP_POSITIVE_X  0
# define CUBE_MAP_NEGATIVE_X  1
# define CUBE_MAP_POSITIVE_Y  2
# define CUBE_MAP_NEGATIVE_Y  3
# define CUBE_MAP_POSITIVE_Z  4
# define CUBE_MAP_NEGATIVE_Z  5


inline void drawHole(const wldPool &p, bool minimap) {
	if(minimap)glBlendFunc(GL_ONE,GL_ONE);
	glBindTexture(GL_TEXTURE_2D, p.faces[0].texture);    // pick the texture of one face
	glBegin(GL_QUADS);
	if(minimap)	drawQuad(p.faces[SideYmax]);
	else
	for(int j=0;j<5;j++)
		drawQuad(p.faces[j]);
	glEnd();
}


class Pool : public Object3d
{
public:
	Pool(int texindex);
	virtual ~Pool();
	void boundingBox(VectorGLf &center, GLfloat &radius, bool in) const
	{center=pos; center.y()=0.5f; radius=0.5f;}
	void boundingSphere(VectorGLf &center, GLfloat &radius) const
	{center=pos; center.y()=0.5f; radius=1.732f/2.f;}
	void setviewer(const Player *player);

	void displayContainer(const World &world, bool minimap) const;
	void display(const World &world, bool minimap) const;
	void update(const VectorGLf &pos);
	bool occludes()const{return false;}
	VectorGLf pos;
	wldPool p;
	int texindex;

	bool isinrange2(const VectorGLf &testpos) const;
	bool isinrange1(const Vector &c) const;
	bool isincloserange2(const VectorGLf &testpos, const VectorGLf &refpos) const;
	bool isnearpool(const VectorGLf &testpos) const;

	int needtoredraw[6];
	VectorGLf playpos;		// Position of the player, relative to the pool

	GLfloat lookupdown, lookleftright;
	bool inside;
};

#endif
