// maxwhite.cc*
// Source Code Copyright
/*
 * lrt source code Copyright(c) 1998-2003 Matt Pharr and Greg Humphreys
 *
 * All Rights Reserved.
 * For non-commercial use only.
 * No warranty, express or implied, for this software.
 */
#include "tonemap.h"
// MaxWhiteOp Declarations
class MaxWhiteOp : public ToneMap {
	void Map(Float *xyz, int xRes, int yRes,
		const DisplayInfo &di) const;
};
// MaxWhiteOp Method Definitions
void MaxWhiteOp::Map(Float *xyz, int xRes, int yRes,
		const DisplayInfo &di) const {
	// Compute maximum luminance of all pixels
	Float maxY = 0.;
	for (int i = 0; i < xRes * yRes; ++i)
		maxY = max(maxY, Y(i));
	Float scale = di.maxDisplayY / maxY;
	// Apply [[scale]] to all image pixels
	for (int i = 0; i < xRes * yRes; ++i) {
		X(i) *= scale;
		Y(i) *= scale;
		Z(i) *= scale;
	}
}
extern "C" ToneMap *CreateToneMap(const ParamSet &ps) {
	return new MaxWhiteOp;
}
